$ verify = 'F$VERIFY(0)'
$!.. EDITHELP.COM		Edit a module in a help library
$L1$:
$ IF p1 .EQS. "" THEN $ INQUIRE  p1  "Help module"
$ IF p1 .EQS. "" THEN $ GOTO L1$
$ p2 = F$PARSE( p2, "CMN$HELP:FERMIHELP.HLB;0")	!Help library specification
$ deletion = 0				!/NODELETE assumed
$ qual = F$ELEMENT( 1, "/", p1)
$ IF qual .EQS. "/" THEN $ GOTO EXTRACTOR
$ IF F$EXTRACT(0,3,qual) .NES. "DEL" THEN $ GOTO BAD_QUALIFIER
$ deletion = 1				!/DELETE found on help specification
$ p1 = F$ELEMENT( 0, "/", p1)
$EXTRACTOR:
$ IF p1 .EQS. ".NEW" THEN $ GOTO EDITOR	!".NEW" means adding new module
$ ON ERROR THEN $ GOTO GET_OUT		!Extract help module to temp file
$ LIBRARY/HELP/EXTRACT='p1'/OUTPUT=EDITHELP.TMP  'p2'
$ IF deletion THEN $ LIBRARY/HELP/DELETE='p1'  'p2'
$EDITOR:
$ ON CONTROL_Y THEN $ GOTO KILL_FILE
$ ON ERROR THEN $ GOTO KILL_FILE
$ ee := EDIT/EDT				!Default to EDT editor
$ IF F$TYPE(EDT) .NES. "" THEN ee = EDT		!If EDT symbol defined...
$ IF F$TYPE(EDTX) .NES. "" THEN ee = EDTX	!If EDTX symbol defined...
$ DEFINE/USER_MODE  SYS$INPUT  SYS$COMMAND:	!Now edit the temp file
$ ee EDITHELP.TMP
$ old_privs = F$SETPRV( "SYSPRV")	!Restore the help module
$ ON ERROR THEN $ GOTO PRESERVE_FILE
$ LIBRARY/HELP/REPLACE/LOG  'p2'  EDITHELP.TMP
$ old_privs = F$SETPRV( old_privs)
$KILL_FILE:
$ DELETE  EDITHELP.TMP;*
$GET_OUT:
$ EXIT	F$VERIFY(verify).OR.1
$PRESERVE_FILE:
$ old_privs = F$SETPRV( old_privs)
$ WRITE SYS$OUTPUT "%EDITHELP-I-PRESERVES, edits saved in file EDITHELP.TMP"
$ EXIT	F$VERIFY(verify).OR.1
$BAD_QUALIFIER:
$ WRITE SYS$OUTPUT "%EDITHELP-F-BADQUAL, qualifier was not /DELete"
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$!+ EDITHELP
$! Procedure to extract a help entry from a library, enter the EDT editor
$! to update the entry and replace in the help library when the edits are
$! completed.  Format:
$!
$!	@FERMI$UTIL:EDITHELP  help-entry[/DELETE]  [library]
$!
$! If the /DELETE qualifier is used on the help entry name, the module
$! will be deleted from the library after being extracted under the
$! assumption that the module name will be changed in the edit session.
$! If a library is not specified, SYS$HELP:FERMIHELP.HLB is assumed.
$! If a library name is given but no device or directory, SYS$HELP: is
$! used as a default.
$!
$! If the help-entry is ".NEW" then no entry will be extracted from the
$! library but EDT will be entered to create a new help entry or entries.
$!-
$!=============================================================================
$! Modifications:
$!  16-Oct-84	FJN	Created to eliminate need for separate help sources
$!  05-Jun-85	FJN	Compacting/moving comments
$!  17-Jun-85	FJN	Change means of extracting /DELETE to use VMS V4
$!			lexical functions; add test for .NEW flag
$!  25-Oct-85	FJN	Preserve EDITHELP.TMP file if problem inserting it
$!  05-Nov-85	FJN	Change default to CMN$HELP
$!  11-Jul-86	FJN	If EDT or EDTX symbols defined, use then to invoke the
$!			editor rather than EDT.
