/* FAB - File Access Block Definitions	*/
/* Extracted from VAXCDEF.TLB and edited on 28-Jun-86 */

struct	$FAB	{
       unsigned char	fab$b_bid;			/* block identification */
#define			FAB$C_BID	3		/* block id constant */

       unsigned char 	fab$b_bln;			/* block length */
#define 		FAB$C_BLN	80		/* block length constant (80 bytes) */
#define 		FAB$K_BLN	80	

	variant_union {
           unsigned short	fab$w_ifi;		/* internal file identifier */
#define			FAB$V_PPF_RAT	6		/* rat value for process-permanent files */
#define			FAB$S_PPF_RAT	8
#define			FAB$M_PPF_RAT	(0x0ff << FAB$V_PPF_RAT)
#define			FAB$V_PPF_IND	14		/* indirect access to process-permanent file */
#define			FAB$M_PPF_IND	(1 << FAB$V_PPF_IND)
	    variant_struct {
		unsigned : FAB$V_PPF_RAT;
		unsigned fab$v_ppf_rat : FAB$S_PPF_RAT;
		unsigned fab$v_ppf_ind : 1;
		} fab$r_ifi;
	    } fab$r_ifi_overlay;

	variant_union {
	    unsigned 	fab$l_fop;			/* file options */
#define			FAB$V_ASY	0		/* Asynchronous operations (not impl.) */
#define			FAB$M_ASY	(1 << FAB$V_ASY)
#define			FAB$V_MXV	1		/* maximize version number */
#define			FAB$M_MXV	(1 << FAB$V_MXV)
#define			FAB$V_SUP	2		/* supersede existing file */
#define			FAB$M_SUP	(1 << FAB$V_SUP)
#define			FAB$V_TMP	3		/* create temporary file */
#define			FAB$M_TMP	(1 << FAB$V_TMP)
#define			FAB$V_TMD	4		/* temporary file marked for delete */
#define			FAB$M_TMD	(1 << FAB$V_TMD)
#define			FAB$V_DFW	5		/* deferred write (rel and idx) */
#define			FAB$M_DFW	(1 << FAB$V_DFW)
#define			FAB$V_SQO	6		/* sequential access only */
#define			FAB$M_SQO	(1 << FAB$V_SQO)
#define			FAB$V_RWO	7		/* rewind magnetic tape on open */
#define			FAB$M_RWO	(1 << FAB$V_RWO)
#define			FAB$V_POS	8		/* use next magnetic tape position */
#define			FAB$M_POS	(1 << FAB$V_POS)
#define			FAB$V_WCK	9		/* write checking */
#define			FAB$M_WCK	(1 << FAB$V_WCK)
#define			FAB$V_NEF	10		/* not end of file, inihibit eof positioning */
#define			FAB$M_NEF	(1 << FAB$V_NEF)
#define			FAB$V_RWC	11		/* rewind magnetic tape on close */
#define			FAB$M_RWC	(1 << FAB$V_RWC)
#define			FAB$V_DMO	12		/* dismount mt on close (not implemented) */
#define			FAB$M_DMO	(1 << FAB$V_DMO)
#define			FAB$V_SPL	13		/* spool file on close */
#define			FAB$M_SPL	(1 << FAB$V_SPL)
#define			FAB$V_SCF	14		/* submit command file on close */
#define			FAB$M_SCF	(1 << FAB$V_SCF)
#define			FAB$V_DLT	15		/* delete file */
#define			FAB$M_DLT	(1 << FAB$V_DLT)
#define			FAB$V_NFS	16		/* non-file-structured operation */
#define			FAB$M_NFS	(1 << FAB$V_NFS)
#define			FAB$V_UFO	17		/* user file open - no rms operation */
#define			FAB$M_UFO	(1 << FAB$V_UFO)
#define			FAB$V_PPF	18		/* process permanent file (pio segment) */
#define			FAB$M_PPF	(1 << FAB$V_PPF)
#define			FAB$V_INP	19		/* process permanent file is 'input' */
#define			FAB$M_INP	(1 << FAB$V_INP)
#define			FAB$V_CTG	20		/* contiguous extension */
#define			FAB$M_CTG	(1 << FAB$V_CTG)
#define			FAB$V_CBT	21		/* contiguous best try */
#define			FAB$M_CBT	(1 << FAB$V_CBT)
#define			FAB$V_JNL	22		/* explicit logging (not implemented) */
#define			FAB$M_JNL	(1 << FAB$V_JNL)
#define			FAB$V_RCK	23		/* read checking */
#define			FAB$M_RCK	(1 << FAB$V_RCK)
#define			FAB$V_NAM	24		/* use NAM block device, file and/or directory id */
#define			FAB$M_NAM	(1 << FAB$V_NAM)
#define			FAB$V_CIF	25		/* create if non-existent */
#define			FAB$M_CIF	(1 << FAB$V_CIF)
#define			FAB$V_UFM	26		/* user file open mode (user if 1, super if 0) 
							   enable only if esc and (ufo or nfs) are also on */
#define			FAB$M_UFM	(1 << FAB$V_UFM)
#define			FAB$V_ESC	27		/* 'escape' to non-standard functions ($modify) */
#define			FAB$M_ESC	(1 << FAB$V_ESC)
#define			FAB$V_TEF	28		/* truncate at end-of-file on close (write-accessed seq. 
							   disk file only) */
#define			FAB$M_TEF	(1 << FAB$V_TEF)
#define			FAB$V_OFP	29		/* output file parse (only name type sticky) */
#define			FAB$M_OFP	(1 << FAB$V_OFP)
#define			FAB$V_KFO	30		/* known file open (image activator only release 1) */
#define			FAB$M_KFO	(1 << FAB$V_KFO)
	    variant_struct {
		unsigned fab$v_asy : 1;	/* Asynchronous operations (not impl.) */
		unsigned fab$v_mxv : 1;	/* maximize version number */
		unsigned fab$v_sup : 1;	/* supersede existing file */
		unsigned fab$v_tmp : 1;	/* create temporary file */
		unsigned fab$v_tmd : 1;	/* temporary file marked for delete */
		unsigned fab$v_dfw : 1;	/* deferred write (rel and idx) */
		unsigned fab$v_sqo : 1;	/* sequential access only */
		unsigned fab$v_rwo : 1;	/* rewind magnetic tape on open */
		unsigned fab$v_pos : 1;	/* use next magnetic tape position */
		unsigned fab$v_wck : 1;	/* write checking */
		unsigned fab$v_nef : 1;	/* not end of file, inihibit eof positioning */
		unsigned fab$v_rwc : 1;	/* rewind magnetic tape on close */
		unsigned fab$v_dmo : 1;	/* dismount mt on close (not implemented) */
		unsigned fab$v_spl : 1;	/* spool file on close */
		unsigned fab$v_scf : 1;	/* submit command file on close */
		unsigned fab$v_dlt : 1;	/* delete file */
		unsigned fab$v_nfs : 1;	/* non-file-structured operation */
		unsigned fab$v_ufo : 1;	/* user file open - no rms operation */
		unsigned fab$v_ppf : 1;	/* process permanent file (pio segment) */
		unsigned fab$v_inp : 1;	/* process permanent file is 'input' */
		unsigned fab$v_ctg : 1;	/* contiguous extension */
		unsigned fab$v_cbt : 1;	/* contiguous best try */
		unsigned fab$v_jnl : 1;	/* explicit logging (not implemented) */
		unsigned fab$v_rck : 1;	/* read checking */
		unsigned fab$v_nam : 1;	/* use NAM block device, file and/or directory id */
		unsigned fab$v_cif : 1;	/* create if non-existent */
		unsigned fab$v_ufm : 1;	/* user file open mode (user if 1, super if 0) 
					   enable only if esc and (ufo or nfs) are also on */
		unsigned fab$v_esc : 1;	/* 'escape' to non-standard functions ($modify) */
		unsigned fab$v_tef : 1;	/* truncate at end-of-file on close (write-accessed seq. 
					   disk file only) */
		unsigned fab$v_ofp : 1;	/* output file parse (only name type sticky) */
		unsigned fab$v_kfo : 1;	/* known file open (image activator only release 1) */
		} fab$r_fop;
	    } fab$r_fop_overlay;

       unsigned int	fab$l_sts;			/* status */
       unsigned int	fab$l_stv;			/* status value */
       unsigned int	fab$l_alq;			/* allocation quantity */
       unsigned short	fab$w_deq;			/* default allocation quantity */

	variant_union {
	    unsigned char fab$b_fac;			/* file access */
#define			FAB$V_PUT	0		/* put access */
#define			FAB$M_PUT	(1 << FAB$V_PUT)
#define			FAB$V_GET	1		/* get access */
#define			FAB$M_GET	(1 << FAB$V_GET)
#define			FAB$V_DEL	2		/* delete access */
#define			FAB$M_DEL	(1 << FAB$V_DEL)
#define			FAB$V_UPD	3		/* update access */
#define			FAB$M_UPD	(1 << FAB$V_UPD)
#define			FAB$V_TRN	4		/* truncate access */
#define			FAB$M_TRN	(1 << FAB$V_TRN)
#define			FAB$V_BIO	5		/* block i/o access */
#define			FAB$M_BIO	(1 << FAB$V_BIO)
#define			FAB$V_BRO	6		/* block and record i/o access */
#define			FAB$M_BRO	(1 << FAB$V_BRO)
#define			FAB$V_EXE	7		/* execute access (caller must be exec or kernel mode, 
							   ufo must also be set) */
#define			FAB$M_EXE	(1 << FAB$V_EXE)
	    variant_struct {
		unsigned fab$v_put : 1;	/* put access */
		unsigned fab$v_get : 1;	/* get access */
		unsigned fab$v_del : 1;	/* delete access */
		unsigned fab$v_upd : 1;	/* update access */
		unsigned fab$v_trn : 1;	/* truncate access */
		unsigned fab$v_bio : 1;	/* block i/o access */
		unsigned fab$v_bro : 1;	/* block and record i/o access */
		unsigned fab$v_exe : 1;	/* execute access (caller must be exec or
					   kernel mode, ufo must also be set) */
		} fab$r_fac;
	    } fab$r_fac_overlay;

	variant_union {
	    unsigned char fab$b_shr;			/* file sharing */
#define			FAB$V_SHRPUT	0			/* put access */
#define			FAB$M_SHRPUT	(1 << FAB$V_SHRPUT)
#define			FAB$V_SHRGET	1			/* get access */
#define			FAB$M_SHRGET	(1 << FAB$V_SHRGET)
#define			FAB$V_SHRDEL	2			/* delete access */
#define			FAB$M_SHRDEL	(1 << FAB$V_SHRDEL)
#define			FAB$V_SHRUPD	3			/* update access */
#define			FAB$M_SHRUPD	(1 << FAB$V_SHRUPD)
#define			FAB$V_MSE	4			/* multi-stream connects enabled */
#define			FAB$M_MSE	(1 << FAB$V_MSE)
#define			FAB$V_NIL	5			/* no sharing */
#define			FAB$M_NIL	(1 << FAB$V_NIL)
#define			FAB$V_UPI	6			/* user provided interlocking (allows multiple */
								/* writers to seq. files) */
#define			FAB$M_UPI	(1 << FAB$V_UPI)
	    variant_struct {
		unsigned fab$v_shrput : 1;	/* put access */
		unsigned fab$v_shrget : 1;	/* get access */
		unsigned fab$v_shrdel : 1;	/* delete access */
		unsigned fab$v_shrupd : 1;	/* update access */
		unsigned fab$v_mse : 1;		/* multi-stream connects enabled */
		unsigned fab$v_nil : 1;		/* no sharing */
		unsigned fab$v_upi : 1;		/* user provided interlocking (allows multiple */
						/* writers to seq. files) */
		} fab$r_shr;
	    } fab$r_shr_overlay;

       unsigned int	fab$l_ctx;			/* user context */
		char	fab$b_rtv;			/* retrieval window size */

	variant_union {
	    unsigned char fab$b_org;			/* file organization */
#define			FAB$V_ORG	4			/* file organization */
#define			FAB$S_ORG	4
#define			FAB$C_SEQ	0			/* sequential */
#define			FAB$C_REL	(1 << FAB$V_ORG)	/* relative */
#define			FAB$C_IDX	(2 << FAB$V_ORG)	/* indexed */
#define			FAB$C_HSH	(3 << FAB$V_ORG)	/* hashed */
	    variant_struct {
		unsigned : 4;
		unsigned fab$v_org : 4;		/* file organization */
#define			FAB$K_SEQ	0	/* sequential */
#define			FAB$K_REL	1	/* relative */
#define			FAB$K_IDX	2	/* indexed */
#define			FAB$K_HSH	3	/* hashed */
		} fab$r_org;
	    } fab$r_org_overlay;

	variant_union {
	    unsigned char fab$b_rat;		/* record attributes */
#define			FAB$V_FTN	0		/* FORTRAN carriage control character */
#define			FAB$M_FTN	(1 << FAB$V_FTN)
#define			FAB$V_CR	1		/* line feed - record -carriage return */
#define			FAB$M_CR	(1 << FAB$V_CR)
#define			FAB$V_PRN	2		/* print-file carriage control */
#define			FAB$M_PRN	(1 << FAB$V_PRN)
#define			FAB$V_BLK	3		/* records don't cross block boundaries */
#define			FAB$M_BLK	(1 << FAB$V_BLK)
	    variant_struct {
		unsigned fab$v_ftn : 1;	/* FORTRAN carriage control character */
		unsigned fab$v_cr : 1;	/* line feed - record -carriage return */
		unsigned fab$v_prn : 1;	/* print-file carriage control */
		unsigned fab$v_blk : 1;	/* records don't cross block boundaries */
		} fab$r_rat;
	    } fab$r_rat_overlay;

       unsigned char	fab$b_rfm;			/* record format */
#define			FAB$C_RFM_DFLT	2		/* variable length is default */
#define			FAB$C_UDF	0		/* undefined */
#define			FAB$C_FIX	1		/* fixed-length record */
#define			FAB$C_VAR	2		/* variable-length record */
#define			FAB$C_VFC	3		/* variable-length with fixed-length control record */
#define 		FAB$C_STM	4		/* RMS-11 stream record (valid only for sequential org) */
#define			FAB$C_STMLF	5		/* stream record delimited by LF (sequential org only) */
#define 		FAB$C_STMCR	6		/* stream record delimited by CR (sequential org only) */
#define			FAB$C_MAXRFM	6		/* maximum rfm supported */

	variant_union {
	    unsigned char fab$b_journal;	/* Journaling options (from fh2$b_journal) */
						/* Note; only one of ru, only_ru, never_ru */
#define			FAB$M_ONLY_RU		0X1
#define			FAB$M_RU		0X2
#define			FAB$M_BI		0X4
#define			FAB$M_AI		0X8
#define			FAB$M_AT		0X10
#define			FAB$M_NEVER_RU		0X20
#define			FAB$M_JOURNAL_FILE	0X40
#define			FAB$V_ONLY_RU		0	/* file is accessible only in recovery unit */
#define			FAB$V_RU		1	/* enable recovery unit journal */
#define			FAB$V_BI		2	/* enable before image journal */
#define			FAB$V_AI		3	/* enable after image journal */
#define			FAB$V_AT		4	/* enable audit trail journal */
#define			FAB$V_NEVER_RU		5	/* file is never accessible in recovery unit */
#define			FAB$V_JOURNAL_FILE	6	/* this is a journal file */
	    variant_struct {
		unsigned fab$v_only_ru : 1;	/* file is accessible only in recovery unit */
		unsigned fab$v_ru : 1;		/* enable recovery unit journal */
		unsigned fab$v_bi : 1;		/* enable before image journal */
		unsigned fab$v_ai : 1;		/* enable after image journal */
		unsigned fab$v_at : 1;		/* enable audit trail journal */
		unsigned fab$v_never_ru : 1;	/* file is never accessible in recovery unit */
		unsigned fab$v_journal_file : 1; /* this is a journal file */
		} fab$r_journal;
	    } fab$r_journal_overlay;

	unsigned char	fab$b_ru_facility;	/* Recoverable facility id number */
	unsigned : 16;
		char	*fab$l_xab;			/* XAB address */
	struct	NAM	*fab$l_nam;			/* NAM block address */
		char	*fab$l_fna;			/* file name string address */
		char	*fab$l_dna;			/* default name string address */
       unsigned char	fab$b_fns;			/* file name string size */
       unsigned char	fab$b_dns;			/* default name string size */
       unsigned short	fab$w_mrs;			/* maximum record size */
       unsigned int	fab$l_mrn;			/* maximum record number */
       unsigned short	fab$w_bls;			/* block size for tape */
       unsigned char	fab$b_bks;			/* bucket size */
       unsigned char	fab$b_fsz;			/* fixed header size */
       unsigned	int	fab$l_dev;			/* device characteristics */
       unsigned	int	fab$l_sdc;			/* spooling device characteristics */
       unsigned short	fab$w_gbc;			/* global buffer count */

	variant_union {
	    unsigned char fab$b_acmodes;	/* agent access modes */
#define			FAB$S_LNM_MODE	2		/* logical names */
#define			FAB$V_LNM_MODE	0
#define			FAB$S_CHAN_MODE	2		/* channel */
#define			FAB$V_CHAN_MODE	2
#define			FAB$S_FILE_MODE	2		/* files accessability */
#define			FAB$V_FILE_MODE	4
#define			FAB$S_CALLERS_MODE	2	/* acmode for user structure probing; */
#define			FAB$V_CALLERS_MODE	6
	    variant_struct {
		unsigned fab$v_lnm_mode : 2;	/* acmode for logical names */
		unsigned fab$v_chan_mode : 2;	/* acmode for channel */
		unsigned fab$v_file_mode : 2;	/* acmode for file's accessability */
		unsigned fab$v_callers_mode : 2; /* acmode for user structure probing; */
		} fab$r_acmodes;
	    } fab$r_acmodes_overlay;

	variant_union {
	    unsigned char fab$b_rcf;		/* recovery control flags */
#define			FAB$M_RCF_RU	0X1
#define			FAB$M_RCF_AI	0X2
#define			FAB$M_RCF_BI	0X4
#define			FAB$V_RCF_RU	0	/* recovery unit recovery */
#define			FAB$V_RCF_AI	1	/* after image recovery */
#define			FAB$V_RCF_BI	2	/* before image recovery */
	    variant_struct {
		unsigned fab$v_rcf_ru : 1;	/* recovery unit recovery */
		unsigned fab$v_rcf_ai : 1;	/* after image recovery */
		unsigned fab$v_rcf_bi : 1;	/* before image recovery */
		} fab$r_rcf;
	    } fab$r_rcf_overlay;
	unsigned : 32;         			/* spare */
    };

#ifdef RMS_GLOBAL_REF
globalref struct $FAB cc$rms_fab;	/* Declare initialized prototype data structure */
#endif
