/*+ $FATDEF
 Record attributes area as used by FCS and RMS.
 Extracted from V4.4 SYS$LIBRARY:STARLET.REQ on  10-Jun-1986
*/
#define FAT$C_UNDEFINED		0	/* undefined record type */
#define FAT$C_FIXED		1	/* fixed record type */
#define FAT$C_VARIABLE		2	/* variable length */
#define FAT$C_VFC		3	/* variable + fixed control */
#define FAT$C_STREAM		4	/* rms-11 (dec traditional) stream format */
#define FAT$C_STREAMLF		5	/* lf-terminated stream format */
#define FAT$C_STREAMCR		6	/* cr-terminated stream format */

#define FAT$C_SEQUENTIAL	0	/* sequential organization */
#define FAT$C_RELATIVE		1	/* relative organization */
#define FAT$C_INDEXED		2	/* indexed organization */
#define FAT$C_DIRECT		3	/* direct organization */

#define FAT$M_FORTRANCC		0X1
#define FAT$M_IMPLIEDCC		0X2
#define FAT$M_PRINTCC		0X4
#define FAT$M_NOSPAN		0X8

#define FAT$K_LENGTH		32
#define FAT$C_LENGTH		32
#define FAT$S_FATDEF		32

struct fatdef {
    variant_union {
	unsigned char fat$b_rtype;	/* record type */
	variant_struct {
	    unsigned fat$v_rtype : 4;	/* record type subfield */
	    unsigned fat$v_fileorg : 4;	/* file organization */
	    } fat$r_rtype;
	} fat$r_rtype_overlay;
    variant_union {
	unsigned char fat$b_rattrib;	/* record attributes */
	variant_struct {
	    unsigned fat$v_fortrancc : 1; /* fortran carriage control */
	    unsigned fat$v_impliedcc : 1; /* implied carriage control */
	    unsigned fat$v_printcc : 1;	/* print file carriage control */
	    unsigned fat$v_nospan : 1;	/* no spanned records */
	    } fat$r_rattrib;
	} fat$r_rattrib_overlay;
    unsigned short fat$w_rsize;		/* record size in bytes */
    variant_union {
	unsigned long fat$l_hiblk;	/* highest allocated vbn */
	variant_struct {
	    unsigned short fat$w_hiblkh;	/* high order word */
	    unsigned short fat$w_hiblkl;	/* low order word */
	    } fat$r_hiblk;
	} fat$r_hiblk_overlay;
    variant_union {
	unsigned long fat$l_efblk;	/* end of file vbn */
	variant_struct {
	    unsigned short fat$w_efblkh;	/* high order word */
	    unsigned short fat$w_efblkl;	/* low order word */
	    } fat$r_efblk;
	} fat$r_efblk_overlay;
    unsigned short fat$w_ffbyte;	/* first free byte in efblk */
    unsigned char fat$b_bktsize;	/* bucket size in blocks */
    unsigned char fat$b_vfcsize;	/* size in bytes of fixed length control for vfc records */
    unsigned short fat$w_maxrec;	/* maximum record size in bytes */
    unsigned short fat$w_defext;	/* default extend quantity */
    unsigned short fat$w_gbc;		/* global buffer count */
    unsigned : 32;
    unsigned : 32;
    unsigned short fat$w_versions;	/* default version limit for directory file */
    }; 
