      subroutine move_to_field( motion, display )

      implicit	none
cc
cc Purpose:	Move the cursor and hi-lite an element name.  Options are:
cc		up, down, right, left, clear.

      include	'libed.fin'
      include	'($smgdef)'
      include	'smg_refs.fin'

      integer*4		motion
      record	/display/	display

      integer*4		line, col, pos, old_pos
      integer*4		smg_stat
      character*80	string

      integer*4		tokens_found, token_start(1:10), token_length(1:10)
      integer*4		i, j

      integer*4	chklen
      external	chklen

cc
cc Clear the old cursor from then screen (turn off reverse video).
      line = display.line
      col = 1

      smg_stat = smg$begin_display_update(display.id)

      smg_stat = smg$set_cursor_abs( display.id, line, col )
      smg_stat = smg$read_from_display( display.id, string )
      call find_tokens( string, 10, 
     +		tokens_found, token_start, token_length )

      do i = 1, tokens_found
         if ((token_start(i) .le. display.column) .and.
     +	     (token_start(i) + token_length(i) - 1 .ge. display.column) )then
            col = display.column
            pos = i
         endif
      enddo

      i = token_start(pos)
      j = i + token_length(pos) - 1
      display.column = i

      smg_stat = smg$put_chars( display.id,
     +		string(i:j),
     +		display.line, display.column, ,
     +		smg$m_reverse, smg$m_reverse)

cc Calculate new position and where to put the cursor.
      if ( (motion .eq. libed_up) .or.
     +	  ((motion .eq. libed_left) .and. (pos .eq. 1)) ) then

         display.line = display.line - 1

         if ((display.line .le. 0) .and.
     +	     (display.bottom .ne. display.height)) then
            smg_stat = smg$set_cursor_abs( display.id, display.height, 1 )
            smg_stat = smg$read_from_display( display.id, string )
            smg_stat = smg$set_cursor_abs( display.id, 1, 1 )
            smg_stat = smg$put_with_scroll( display.id, string,
     +						 smg$m_down )
            smg_stat = smg$change_virtual_display( display.id,
     +				display.height, display.width )
            display.line = 1

          else if (display.line .le. 0) then
            display.line = display.height
         endif

         display.column = 1

         line = display.line
         col = 1

         smg_stat = smg$set_cursor_abs( display.id, line, col )
         smg_stat = smg$read_from_display( display.id, string )

         call find_tokens( string, 10, 
     +		tokens_found, token_start, token_length )

         if (motion .eq. libed_left) pos = tokens_found + 1

       else if ( (motion .eq. libed_down) .or.
     +		((motion .eq. libed_right) .and. (pos .eq. tokens_found)) ) then

         display.line = display.line + 1

         if ((display.line .gt. display.bottom) .and.
     +	     (display.bottom .ne. display.height)) then
            smg_stat = smg$set_cursor_abs( display.id, 1, 1 )
            smg_stat = smg$read_from_display( display.id, string )
            smg_stat = smg$delete_line( display.id, 1, 1 )
            smg_stat = smg$set_cursor_abs( display.id, display.height, 1 )
            smg_stat = smg$put_line( display.id, string )
            display.line = display.line - 1

          else if (display.line .gt. display.height) then
            display.line = 1
         endif

         display.column = 1

         line = display.line
         col = 1

         smg_stat = smg$set_cursor_abs( display.id, line, col )
         smg_stat = smg$read_from_display( display.id, string )

         call find_tokens( string, 10, 
     +		tokens_found, token_start, token_length )

         if (motion .eq. libed_right) pos = 0

      endif

      line = display.line
      col = 1

      if ((motion .eq. libed_up) .or.
     +    (motion .eq. libed_down)) then
         pos = min( pos, tokens_found )

       else if (motion .eq.libed_right) then
         pos = pos + 1

       else if (motion .eq.libed_left) then
         pos = pos - 1

      endif

      i = token_start(pos)
      j = i + token_length(pos) - 1
      display.column = i

cc Except when clearing the cursor, hi-lite the new position.
      if (motion .ne. libed_clear) then
         smg_stat = smg$put_chars( display.id,
     +		string(i:j),
     +		display.line, display.column, ,
     +		smg$m_reverse, )
      endif

      smg_stat = smg$end_display_update(display.id)

      end
