$!
$!	Software Tools installation procedure for VAX/VMS
$!
$ write sys$output "The Software Tools logical names are currently:"
$ @dsplog
$ inquire ans "Are these correct for your installation? [y/n]"
$ if ans .eqs. "y" then goto cont
$ if ans .eqs. "Y" then goto cont
$ write sys$output "Please edit the file stlognam.com to reflect your"
$ write sys$output "installation and then invoke toolgen again."
$ write sys$output "Consult the file readme.1st for details."
$ goto abort
$ cont:
$ inquire ans "Have you created the 6 known directories? [y/n]"
$ if ans .eqs. "y" then goto cont1
$ if ans .eqs. "Y" then goto cont1
$ write sys$output "You must create the directories before proceeding."
$ write sys$output "Consult the file release.doc for information on"
$ write sys$output "the protection modes required."
$ goto abort
$ cont1:
$ inquire/global shared "Do you wish to link to a shared library? [y/n]
$ inquire/global remfor "Do you wish to remove the sources as we progress? [y/n]"
$ inquire/global remobj "Do you wish to remove the objects as we progress? [y/n]"
$ inquire/global vmsv3 "Do you wish to build the tools for VMS V3.x? [y/n]"
$ write sys$output "shared = ''shared'"
$ write sys$output "remfor = ''remfor'"
$ write sys$output "remobj = ''remobj'"
$ write sys$output "vmsv3  = ''vmsv3'"
$ write sys$output ""
$ write sys$output "[Toolgen started at ", "''f$time()'", "]"
$ write sys$output ""
$ set verify
$!
$!	Assemble the primitives
$!
$ @asmprm
$!
$!	Assemble the optimized library routines
$!
$ @asmlib
$ @compile
$ @library
$ if remfor .eqs. "y" then delete *.mar.*,*.ff.*
$ if remfor .eqs. "Y" then delete *.mar.*,*.ff.*
$ if remobj .eqs. "y" then delete *.obj.*
$ if remobj .eqs. "Y" then delete *.obj.*
$ if shared .eqs. "y" then goto cont2
$ if shared .nes. "Y" then goto cont3
$ cont2:
$ @startup.cmd
$ @directory.cmd
$ @hispmt.cmd
$ @lnedit.cmd
$ @pattern.cmd
$ @rawpmt.cmd
$ @spawn.cmd
$ @rest.cmd
$ @rlibshare.com
$ delete *.cob.*
$ delete *.cmd.*
$ cont3:
$!
$!	build the software tools utilities
$!
$ delete st_tmp:*.fmt.*
$ @fbuild
$ set noverify
$ @st_bin:tooldef
$ set verify
$ sh -v
#
#	generate dictionary index
#
isam <dict >dictdx -d20
#
#	move msg help file to ~msg
#
mv msghlp ~msg/msghlp
#
#	generate address file for tools
#
addr >~msg/address
#
#	move manual sections to ~man
#
build1
build234
mv sect1 ~man/s1
mv sect2 ~man/s2
mv sect3 ~man/s3
mv sect4 ~man/s4
mv mpath ~man/mpath
format mintro.fmt >mintro
mv mintro ~man/mintro
#
#	generate indices to manual sections in ~man
#
asam <~man/s1 | sort >~man/i1
asam <~man/s2 | sort >~man/i2
asam <~man/s3 | sort >~man/i3
asam <~man/s4 | sort >~man/i4
#
#	build ~bin/sysuaf.mod to modify accounts in case this is first toolgen
#
ed - <sysuaf.eds
$ set noverify
$ if shared .eqs. "y" then goto cont4
$ if shared .eqs. "Y" then goto cont4
$ write sys$output -
"Be sure to remove the definition of RLIBSHARE from stlognam.com!"
$!
$ cont4:
$ write sys$output ""
$ write sys$output "[Toolgen completed at ", "''f$time()'", "]"
$ exit
$!
$ abort:
$ write sys$output ""
$ write sys$output "[Toolgen aborted at ", "''f$time()'", "]"
$ exit
