/*--- EDIT # 0012	20 Feb 1986   13:43:08	SYS$SYSROOT:[VANTASSLE.UTILS]ERROR.C;19  */
/*--- PREVIOUS EDIT	28 Mar 1983   12:07:38	DB1:[21,112]ERROR.C;21  */
/*
.title error
;+
; index error exit from C programs
; index exit status
;
; Usage
;	VOID error(s1, s2)
;
; in
;	char *s1, *s2;
;
; out
;
;
;
; Description
;	An error message is written to stderr and the program exits.
;	The message is the  program name, followed by strings s1 and s2.
;	Either s1 or s2 may be NULL.
;
;	If the exit status (__exst) is EX_SUC, it will be set to "EX_ERR".
;
;	If the address of a routine is moved to __errx, it will
;	be called just before calling exit. This is normally used
;	only by the machine trap error routine.
;
; status
;
;
; bugs
;
;
;
;
; Updates
;	 Date		Vers 	Who	Description
;	 4-may-82	0001	RVT	initial edit	
;	 22-Jun-82	0002	RVT	use puts instead of write
;	 25-Jun-82	0003	RVT	add __errx routine call
;	 28 Mar 1983	0004	RVT	only call errx once.
;	 20 Feb 1986	0005	RVT	Fix for VAX rules.
;
;-
*/
/* ERROR - PRINT FATAL ERROR MESSAGE
*/

#include <stdio.h>

VOID (*__errx)() = NULL;
static int ftf = -1;	/* -1 means never failed, 0 = failed once */

IMPORT int __exst;	/* program exit status */
IMPORT char __pname[];	/* task name */

VOID error(s1, s2)
char *s1, *s2;
{
   if (++ftf != 0)   /* Call it One-time only!! */
      __errx = NULL;
   putc('\n', stderr);
   fputs(__pname, stderr);
   fputs(": ", stderr);
   if (s1 != NULL)
fputs(s1, stderr);
   putc(' ', stderr);
  if (s2 != NULL)
   fputs(s2, stderr);
  putc('\n', stderr);
   if (__errx != NULL)
      (*__errx)();
   if (__exst == EX_SUC)
      exits(EX_ERR);
   else
      exits(EX_ERR);
}
